#
# Copyright (c) 2006 Mellanox Technologies. All rights reserved.
#
# This Software is licensed under one of the following licenses:
#
# 1) under the terms of the "Common Public License 1.0" a copy of which is
#    available from the Open Source Initiative, see
#    http://www.opensource.org/licenses/cpl.php.
#
# 2) under the terms of the "The BSD License" a copy of which is
#    available from the Open Source Initiative, see
#    http://www.opensource.org/licenses/bsd-license.php.
#
# 3) under the terms of the "GNU General Public License (GPL) Version 2" a
#    copy of which is available from the Open Source Initiative, see
#    http://www.opensource.org/licenses/gpl-license.php.
#
# Licensee has the right to choose one of the above licenses.
#
# Redistributions of source code must retain the above copyright
# notice and one of the license notices.
#
# Redistributions in binary form must reproduce both the above copyright
# notice, one of the license notices in the documentation
# and/or other materials provided with the distribution.
#
#

%{!?KVERSION: %define KVERSION %(uname -r)}
%define krelver %(echo -n %{KVERSION} | sed -e 's/-/_/g')

%{!?build_mlnx_en: %define build_mlnx_en 1}
%{!?build_mlnx_en_devel: %define build_mlnx_en_devel 1}
%define _prefix /usr/mellanox/

%{!?sysctl_update: %define sysctl_update 1}

%{!?LIB_MOD_DIR: %define LIB_MOD_DIR /lib/modules/%{KVERSION}/updates}

%define LIB_MOD_DIR_NET %{LIB_MOD_DIR}/kernel/drivers/net
%define LIB_MOD_DIR_KERNEL_NET %{LIB_MOD_DIR}/kernel/net


%{!?K_SRC: %define K_SRC /lib/modules/%{KVERSION}/build}

%{!?KERNEL_SOURCES: %define KERNEL_SOURCES /lib/modules/%{KVERSION}/source}


# Disable debugging
%define debug_package %{nil}
%define __check_files %{nil}

# Disable brp-lib64-linux
%ifarch x86_64 ia64
%define __arch_install_post %{nil}
%endif

%{!?_name: %define _name mlnx_en}
%{!?_version: %define _version 1.5.7}
%{!?_release: %define _release 0}

Summary: Ethernet NIC Driver
Name: %{_name}
PreReq: coreutils
PreReq: kernel
Prereq: pciutils
Prereq: grep
Prereq: perl
Prereq: procps
Prereq: module-init-tools
Version: %{_version}
Release: %{_release}
License: GPL/BSD
Url: http://Mellanox.com/
Group: System Environment/Base
Source: %{_name}-%{_version}.tgz
BuildRoot: %{?build_root:%{build_root}}%{!?build_root:/var/tmp/MLNX_EN}
Vendor: Mellanox technologies 
%description
ConnectX Ehternet device driver

BuildRequires: sysfsutils-devel

%package -n mlnx-en-devel
PreReq: coreutils
PreReq: kernel
Prereq: pciutils
Version: %{_version}
Release: %{krelver}
Summary: ConnectX Ehternet device driver kernel modules sources
Group: System Environment/Libraries
%description -n mlnx-en-devel
Kernel modules sources

#################################################################################################################################

%prep
%setup -n %{_name}-%{_version}

###
### build
###
%build
rm -rf $RPM_BUILD_ROOT
cd $RPM_BUILD_DIR/%{_name}-%{_version}

MLNX_EN_PATCH_PARAMS=""

%if %{MEMTRACK}
MLNX_EN_PATCH_PARAMS=(${MLNX_EN_PATCH_PARAMS} " --with-memtrack")
%endif

scripts/mlnx_en_patch.sh $MLNX_EN_PATCH_PARAMS

# Save clean sources
mkdir -p $RPM_BUILD_ROOT/%{_prefix}
install -d $RPM_BUILD_ROOT/%{_prefix}%{_name}
mkdir -p $RPM_BUILD_DIR/src/
cp -a $RPM_BUILD_DIR/%{_name}-%{_version}/* $RPM_BUILD_DIR/src/
echo ${RPM_BUILD_DIR}/%{_name}-%{_version}
sed -i -e "s@${RPM_BUILD_DIR}/%{_name}-%{_version}@%{_prefix}%{_name}@g" $RPM_BUILD_DIR/src/config.mk

%if %{build_mlnx_en}
make 
gzip -c scripts/mlx4_en.7 > mlx4_en.7.gz
%endif

###
### install
###
%install
mkdir -p $RPM_BUILD_ROOT/%{_prefix}/%{_name}/
cp -a $RPM_BUILD_DIR/src/* $RPM_BUILD_ROOT/%{_prefix}/%{_name}
rm -rf $RPM_BUILD_DIR/src
%if %{build_mlnx_en}
mkdir -p $RPM_BUILD_ROOT/%{LIB_MOD_DIR}
make install MODULES_DIR=%{LIB_MOD_DIR} DESTDIR=$RPM_BUILD_ROOT KERNELRELEASE=%{KVERSION}
modsyms=`find $RPM_BUILD_DIR/%{_name}-%{_version} -name Module.symvers -o -name Modules.symvers`
for modsym in $modsyms
do
        cat $modsym >> $RPM_BUILD_ROOT/%{_prefix}/%{_name}/Module.symvers
	sed -i -e "s@${RPM_BUILD_DIR}/%{_name}-%{_version}@%{_prefix}%{_name}@g" $RPM_BUILD_ROOT/%{_prefix}/%{_name}/Module.symvers
done
install -D -m 644 mlx4_en.7.gz $RPM_BUILD_ROOT/usr/share/man/man7/mlx4_en.7.gz
%endif

%clean
#Remove installed driver after rpm build finished
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{_name}-%{_version}

###
### pre section
###

%pre -n mlnx_en 

%pre -n mlnx-en-devel

###
### post section
###

%post -n mlnx_en

#############################################################################################################
#                                       Modules configuration                                               #
#############################################################################################################
%if %{sysctl_update}

sysctl -q -w net.ipv4.tcp_timestamps=0
sysctl -q -w net.ipv4.tcp_sack=0
sysctl -q -w net.ipv4.tcp_low_latency=1
sysctl -q -w net.core.netdev_max_backlog=250000
sysctl -q -w net.core.rmem_max=16777216
sysctl -q -w net.core.wmem_max=16777216
sysctl -q -w net.core.rmem_default=16777216
sysctl -q -w net.core.wmem_default=16777216
sysctl -q -w net.core.optmem_max=16777216
sysctl -q -w net.ipv4.tcp_mem="16777216 16777216 16777216"
sysctl -q -w net.ipv4.tcp_rmem="4096 87380 16777216"
sysctl -q -w net.ipv4.tcp_wmem="4096 65536 16777216"

if [ -f /etc/sysctl.conf ]; then
perl -ni -e 'if (/\#\# MLXNET tuning parameters \#\#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\#\# END MLXNET \#\#$/){ $filter = 0 }' /etc/sysctl.conf
cat << EOF >> /etc/sysctl.conf
## MLXNET tuning parameters ##
net.ipv4.tcp_timestamps = 0
net.ipv4.tcp_sack = 0
net.ipv4.tcp_low_latency = 1
net.core.netdev_max_backlog = 250000
net.core.rmem_max = 16777216
net.core.wmem_max = 16777216
net.core.rmem_default = 16777216
net.core.wmem_default = 16777216
net.core.optmem_max = 16777216
net.ipv4.tcp_mem = 16777216 16777216 16777216
net.ipv4.tcp_rmem = 4096 87380 16777216
net.ipv4.tcp_wmem = 4096 65536 16777216
## END MLXNET ##
EOF
fi

%endif

/sbin/depmod -r -ae %{KVERSION}
if [ -f /usr/share/man/man7/mlx4_en.7.gz ]; then
        exit 0
fi

#############################################################################################################

# END of post -n mlnx-en 

%post -n mlnx-en-devel

###
### preun section
###

%preun -n mlnx_en

###
### post uninstall section
###
%postun -n mlnx_en
if [ $1 = 0 ]; then  # 1 : Erase, not upgrade
        # Remove previous configuration if exist
        /sbin/depmod -r -ae %{KVERSION}


# Clean sysctl.conf
if [ -f /etc/sysctl.conf ]; then
perl -ni -e 'if (/\#\# MLXNET tuning parameters \#\#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\#\# END MLXNET \#\#$/){ $filter = 0 }' /etc/sysctl.conf
fi

fi

%postun -n mlnx-en-devel

###
### Files
###
%if %{build_mlnx_en}
%files -n mlnx_en
%defattr(-,root,root,-)
%{LIB_MOD_DIR_NET}/mlx4
/usr/share/man/man7/mlx4_en.7.gz
%endif

%if %{build_mlnx_en_devel}
%files -n mlnx-en-devel
%defattr(-,root,root,-)
%dir %{_prefix}
%{_prefix}/%{_name}
%endif

# END Files

%changelog
* Wed Sep 8 2008 Vladimir Sokolovsky <vlad@mellanox.co.il>
- Added nfsrdma support
* Wed Aug 13 2008 Vladimir Sokolovsky <vlad@mellanox.co.il>
- Added mlx4_en support
* Tue Aug 21 2007 Vladimir Sokolovsky <vlad@mellanox.co.il>
- Added %build macro
* Sun Jan 28 2007 Vladimir Sokolovsky <vlad@mellanox.co.il>
- Created spec file for kernel-ib
